Summary: tcl, tk, tix, tclX, and expect
Name: tcltk
Version: 8.0
Release: 12
Source0: ftp://ftp.smli.com/pub/tcl/tcl8.0.tar.gz
Source1: ftp://ftp.smli.com/pub/tcl/tk8.0.tar.gz
Source2: ftp://ftp.cme.nist.gov/pub/expect/expect.tar.gz
Source3: ftp://ftp.neosoft.com/pub/tcl/tclx-distrib/tclX8.0.0b3.tar.gz
Source4: ftp://ftp.xpi.com/pub/ioi/Tix4.1.0.005.tar.gz
Patch: tcltk-8.0-ieee.patch
Copyright: BSD
Group: Development/Languages/Tcl
BuildRoot: /var/tmp/tclroot

%changelog

* Thu Oct 30 1997 Otto Hammersmith <otto@redhat.com>

- fixed filelist for tix... replacing path to the expect binary in scripts
  was leaving junk files around.

* Wed Oct 22 1997 Otto Hammersmith <otto@redhat.com>

- added patch to remove libieee test in configure.in for tcl and tk.
  Shoudln't be needed anymore for glibc systems, but this isn't the "proper" 
  solution for all systems
- fixed src urls

* Mon Oct 06 1997 Erik Troan <ewt@redhat.com>

- removed version numbers from descriptions

* Mon Sep 22 1997 Erik Troan <ewt@redhat.com>

- updated to tcl/tk 8.0 and related versions of packages

* Tue Jun 17 1997 Erik Troan <ewt@redhat.com>

- built against glibc
- fixed dangling tclx/tkx symlinks

%description
Source package for tcl, tk, tix, tclX, and expect. The binary packages
include descriptions of the functionality provided by each portion
of this package.

%package -n tcl
Version: 8.0
Summary: Tool Command Language embeddable scripting language, with shared libraries
Group: Development/Languages/Tcl

%description -n tcl
TCL is a simple scripting language that is designed to be embedded in
other applications. This package includes tclsh, a simple example of a
tcl application. TCL is very popular for writing small graphical applications
because of the TK widget set which is closely tied to it.

%package -n tk
Version: 8.0
Summary: Tk GUI toolkit for Tcl, with shared libraries
Group: Development/Languages/Tcl

%description -n tk
Tk is a X Windows widget set designed to work closely with the tcl
scripting language. It allows you to write simple programs with full
featured GUI's in only a little more time then it takes to write a
text based interface. Tcl/Tk applications can also be run on Windows
and Macintosh platforms.

%package -n expect
Summary: tcl extension to allow interaction between programs and scripts
Group: Development/Languages/Tcl
Version: 5.24

%description -n expect
Expect is a tool for automating interactive applications such as
telnet, ftp, passwd, fsck, rlogin, tip, etc. It makes it easy for a
script to control another program and interact with it.

%package -n tclx
Summary: extensions to tcl and tk for POSIX systems
Group: Development/Languages/Tcl
Version: 8.0.0.0

%description -n tclx
TclX is a set of extensions to make it more suitable for common Unix
programming tasks. It adds or enhances support for files, network access,
debugging, math, lists, and message catalogs. It can be used with both
tcl and tcl/tk applications.

%package -n tix 
Summary: many metawidgets (such as notepads) for tk
Group: Development/Languages/Tcl
Version: 4.1.0.5

%description -n tix
Tix is a add on for the tk widget set which adds many complex widgets which
are built from tk building blocks. The extra widgets include combo box,
file selection, notebooks, paned windows, spin controls, and hierarchical
list boxes.

%prep

%setup -c -a 1 -a 2 -a 3 -a 4
%patch -p1
cd tcl8.0/unix
autoconf
cd ../../
cd tk8.0/unix
autoconf

%build

# make the libraries reentrant
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -D_REENTRANT"

#
# Tcl
#
cd tcl8.0/unix
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-shared --enable-gcc
make
cd ../..

#
# Tk
#
cd tk8.0/unix
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-shared --enable-gcc
make
cd ../..

#
# tclX
#
cd tclX8.0.0b3/unix
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-shared
make
cd ../..

#
# Expect
#
cd expect-5.24
CFLAGS="$RPM_OPT_FLAGS" ./configure --enable-gcc --enable-shared --prefix=/usr
make
cd ..

#
# Tix
#
cd Tix4.1.0/unix
./configure --prefix=/usr --disable-cdemos --enable-shared
cd tk8.0
./configure --prefix=/usr --disable-cdemos --enable-shared
make
cd ../../..

%install

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr

#
# Tcl
#
cd tcl8.0/unix
make INSTALL_ROOT=$RPM_BUILD_ROOT install
ln -sf libtcl8.0.so $RPM_BUILD_ROOT/usr/lib/libtcl.so
ln -sf tclsh8.0 $RPM_BUILD_ROOT/usr/bin/tclsh
cd ../..
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | sort > tcl.files

#
# Tk
#
cd tk8.0/unix
make INSTALL_ROOT=$RPM_BUILD_ROOT install
ln -sf libtk8.0.so $RPM_BUILD_ROOT/usr/lib/libtk.so
ln -sf wish8.0 $RPM_BUILD_ROOT/usr/bin/wish
cd ../..
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files \
	| sort | uniq -u > tk.files

#
# TclX
#
cd tclX8.0.0b3/unix
make INSTALL_ROOT=$RPM_BUILD_ROOT install
ln -sf libtkx8.0.0.so $RPM_BUILD_ROOT/usr/lib/libtkx.so
ln -sf libtclx8.0.0.so $RPM_BUILD_ROOT/usr/lib/libtclx.so
cd ../..
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tk.files \
	| sort | uniq -u > tclx.files

#
# Expect
#
cd expect-5.24
LD_LIBRARY_PATH=$RPM_BUILD_ROOT/usr/lib make prefix=$RPM_BUILD_ROOT/usr install
cd ..
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tk.files tclx.files \
	| sort | uniq -u > expect.files

# for files in expect.files, sed the #! at the top...
for n in `cat expect.files`; do
	if head -1 $n | grep '#!'; then
		mv $n $n.in
		sed "s|$RPM_BUILD_ROOT||" < $n.in > $n
		rm -f $n.in
	fi
done

#
# Tix
#
cd Tix4.1.0/unix
LD_LIBRARY_PATH=$RPM_BUILD_ROOT/usr/lib make prefix=$RPM_BUILD_ROOT/usr install
cd ../..
mv $RPM_BUILD_ROOT/usr/man/mann/tixwish.1 $RPM_BUILD_ROOT/usr/man/man1/tixwish.1
ln -sf libtix4.1.8.0.so $RPM_BUILD_ROOT/usr/lib/libtix.so
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tk.files tclx.files expect.files\
	| sort | uniq -u > tix.files

for n in `cat tix.files`; do
        if head -1 $n | grep '#!'; then
                mv $n $n.in
                sed "s|$RPM_BUILD_ROOT||" < $n.in > $n
		rm -f $n.in
        fi
done

# this is too annoying to watch
set +x
for n in *.files; do
	mv $n $n.in
	sed "s|.*/usr|/usr|" < $n.in | while read file; do
	    if [ -d $RPM_BUILD_ROOT/$file ]; then
		echo -n '%dir '
	    fi
	    echo $file
	done > $n
done
set -x

%post -n tcl -p /sbin/ldconfig

%post -n tk -p /sbin/ldconfig

%post -n expect -p /sbin/ldconfig

%post -n tclx -p /sbin/ldconfig

%post -n tix -p /sbin/ldconfig

%postun -n tcl -p /sbin/ldconfig

%postun -n tk -p /sbin/ldconfig

%postun -n expect -p /sbin/ldconfig

%postun -n tclx -p /sbin/ldconfig

%postun -n tix -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files -n tcl -f tcl.files

%files -n tk -f tk.files

%files -n tclx -f tclx.files

%files -n tix -f tix.files

%files -n expect -f expect.files
